const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2014-03-28";
pub const sdk_id: []const u8 = "CloudWatch Logs";
pub const arn_namespace: []const u8 = "logs";
pub const endpoint_prefix: []const u8 = "logs";
pub const sigv4_name: []const u8 = "logs";
pub const name: []const u8 = "Logs_20140328";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2014-03-28",
    sdk_id: []const u8 = "CloudWatch Logs",
    arn_namespace: []const u8 = "logs",
    endpoint_prefix: []const u8 = "logs",
    sigv4_name: []const u8 = "logs",
    name: []const u8 = "Logs_20140328",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_kms_key: struct {
    action_name: []const u8 = "AssociateKmsKey",
    Request: type = struct {
        log_group_name: []const u8,
        kms_key_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .kms_key_id = "kmsKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_kms_key) } {
            return .{ .service_metadata = service_metadata, .action = associate_kms_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const cancel_export_task: struct {
    action_name: []const u8 = "CancelExportTask",
    Request: type = struct {
        task_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_id = "taskId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(cancel_export_task) } {
            return .{ .service_metadata = service_metadata, .action = cancel_export_task };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidOperation,
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const create_export_task: struct {
    action_name: []const u8 = "CreateExportTask",
    Request: type = struct {
        task_name: ?[]const u8 = null,
        log_group_name: []const u8,
        log_stream_name_prefix: ?[]const u8 = null,
        from: i64,
        to: i64,
        destination: []const u8,
        destination_prefix: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_name = "taskName",
                .log_group_name = "logGroupName",
                .log_stream_name_prefix = "logStreamNamePrefix",
                .from = "from",
                .to = "to",
                .destination = "destination",
                .destination_prefix = "destinationPrefix",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_export_task) } {
            return .{ .service_metadata = service_metadata, .action = create_export_task };
        }
    },
    Response: type = struct {
        task_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_id = "taskId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        OperationAborted,
        ResourceAlreadyExists,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const create_log_group: struct {
    action_name: []const u8 = "CreateLogGroup",
    Request: type = struct {
        log_group_name: []const u8,
        kms_key_id: ?[]const u8 = null,
        tags: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .kms_key_id = "kmsKeyId",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_log_group) } {
            return .{ .service_metadata = service_metadata, .action = create_log_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        OperationAborted,
        ResourceAlreadyExists,
        ServiceUnavailable,
    },
} = .{};
pub const create_log_stream: struct {
    action_name: []const u8 = "CreateLogStream",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_name = "logStreamName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_log_stream) } {
            return .{ .service_metadata = service_metadata, .action = create_log_stream };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        ResourceAlreadyExists,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_destination: struct {
    action_name: []const u8 = "DeleteDestination",
    Request: type = struct {
        destination_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destination_name = "destinationName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_destination) } {
            return .{ .service_metadata = service_metadata, .action = delete_destination };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_log_group: struct {
    action_name: []const u8 = "DeleteLogGroup",
    Request: type = struct {
        log_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_log_group) } {
            return .{ .service_metadata = service_metadata, .action = delete_log_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_log_stream: struct {
    action_name: []const u8 = "DeleteLogStream",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_name = "logStreamName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_log_stream) } {
            return .{ .service_metadata = service_metadata, .action = delete_log_stream };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_metric_filter: struct {
    action_name: []const u8 = "DeleteMetricFilter",
    Request: type = struct {
        log_group_name: []const u8,
        filter_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name = "filterName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_metric_filter) } {
            return .{ .service_metadata = service_metadata, .action = delete_metric_filter };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_query_definition: struct {
    action_name: []const u8 = "DeleteQueryDefinition",
    Request: type = struct {
        query_definition_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_definition_id = "queryDefinitionId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_query_definition) } {
            return .{ .service_metadata = service_metadata, .action = delete_query_definition };
        }
    },
    Response: type = struct {
        success: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .success = "success",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_resource_policy: struct {
    action_name: []const u8 = "DeleteResourcePolicy",
    Request: type = struct {
        policy_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_name = "policyName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_resource_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_retention_policy: struct {
    action_name: []const u8 = "DeleteRetentionPolicy",
    Request: type = struct {
        log_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_retention_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_retention_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const delete_subscription_filter: struct {
    action_name: []const u8 = "DeleteSubscriptionFilter",
    Request: type = struct {
        log_group_name: []const u8,
        filter_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name = "filterName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_subscription_filter) } {
            return .{ .service_metadata = service_metadata, .action = delete_subscription_filter };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const describe_destinations: struct {
    action_name: []const u8 = "DescribeDestinations",
    Request: type = struct {
        destination_name_prefix: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destination_name_prefix = "DestinationNamePrefix",
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_destinations) } {
            return .{ .service_metadata = service_metadata, .action = describe_destinations };
        }
    },
    Response: type = struct {
        destinations: ?[]Destination = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destinations = "destinations",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const describe_export_tasks: struct {
    action_name: []const u8 = "DescribeExportTasks",
    Request: type = struct {
        task_id: ?[]const u8 = null,
        status_code: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .task_id = "taskId",
                .status_code = "statusCode",
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_export_tasks) } {
            return .{ .service_metadata = service_metadata, .action = describe_export_tasks };
        }
    },
    Response: type = struct {
        export_tasks: ?[]struct {
            task_id: ?[]const u8 = null,
            task_name: ?[]const u8 = null,
            log_group_name: ?[]const u8 = null,
            from: ?i64 = null,
            to: ?i64 = null,
            destination: ?[]const u8 = null,
            destination_prefix: ?[]const u8 = null,
            status: ?struct {
                code: ?[]const u8 = null,
                message: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .code = "code",
                        .message = "message",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            execution_info: ?struct {
                creation_time: ?i64 = null,
                completion_time: ?i64 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .creation_time = "creationTime",
                        .completion_time = "completionTime",
                    };
                    return @field(mappings, field_name);
                }
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .task_id = "taskId",
                    .task_name = "taskName",
                    .log_group_name = "logGroupName",
                    .from = "from",
                    .to = "to",
                    .destination = "destination",
                    .destination_prefix = "destinationPrefix",
                    .status = "status",
                    .execution_info = "executionInfo",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .export_tasks = "exportTasks",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const describe_log_groups: struct {
    action_name: []const u8 = "DescribeLogGroups",
    Request: type = struct {
        log_group_name_prefix: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name_prefix = "logGroupNamePrefix",
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_log_groups) } {
            return .{ .service_metadata = service_metadata, .action = describe_log_groups };
        }
    },
    Response: type = struct {
        log_groups: ?[]struct {
            log_group_name: ?[]const u8 = null,
            creation_time: ?i64 = null,
            retention_in_days: ?i64 = null,
            metric_filter_count: ?i64 = null,
            arn: ?[]const u8 = null,
            stored_bytes: ?i64 = null,
            kms_key_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .log_group_name = "logGroupName",
                    .creation_time = "creationTime",
                    .retention_in_days = "retentionInDays",
                    .metric_filter_count = "metricFilterCount",
                    .arn = "arn",
                    .stored_bytes = "storedBytes",
                    .kms_key_id = "kmsKeyId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_groups = "logGroups",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const describe_log_streams: struct {
    action_name: []const u8 = "DescribeLogStreams",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_name_prefix: ?[]const u8 = null,
        order_by: ?[]const u8 = null,
        descending: ?bool = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_name_prefix = "logStreamNamePrefix",
                .order_by = "orderBy",
                .descending = "descending",
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_log_streams) } {
            return .{ .service_metadata = service_metadata, .action = describe_log_streams };
        }
    },
    Response: type = struct {
        log_streams: ?[]struct {
            log_stream_name: ?[]const u8 = null,
            creation_time: ?i64 = null,
            first_event_timestamp: ?i64 = null,
            last_event_timestamp: ?i64 = null,
            last_ingestion_time: ?i64 = null,
            upload_sequence_token: ?[]const u8 = null,
            arn: ?[]const u8 = null,
            stored_bytes: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .log_stream_name = "logStreamName",
                    .creation_time = "creationTime",
                    .first_event_timestamp = "firstEventTimestamp",
                    .last_event_timestamp = "lastEventTimestamp",
                    .last_ingestion_time = "lastIngestionTime",
                    .upload_sequence_token = "uploadSequenceToken",
                    .arn = "arn",
                    .stored_bytes = "storedBytes",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_streams = "logStreams",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const describe_metric_filters: struct {
    action_name: []const u8 = "DescribeMetricFilters",
    Request: type = struct {
        log_group_name: ?[]const u8 = null,
        filter_name_prefix: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,
        metric_name: ?[]const u8 = null,
        metric_namespace: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name_prefix = "filterNamePrefix",
                .next_token = "nextToken",
                .limit = "limit",
                .metric_name = "metricName",
                .metric_namespace = "metricNamespace",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_metric_filters) } {
            return .{ .service_metadata = service_metadata, .action = describe_metric_filters };
        }
    },
    Response: type = struct {
        metric_filters: ?[]struct {
            filter_name: ?[]const u8 = null,
            filter_pattern: ?[]const u8 = null,
            metric_transformations: ?[]MetricTransformation = null,
            creation_time: ?i64 = null,
            log_group_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .filter_name = "filterName",
                    .filter_pattern = "filterPattern",
                    .metric_transformations = "metricTransformations",
                    .creation_time = "creationTime",
                    .log_group_name = "logGroupName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .metric_filters = "metricFilters",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const describe_queries: struct {
    action_name: []const u8 = "DescribeQueries",
    Request: type = struct {
        log_group_name: ?[]const u8 = null,
        status: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .status = "status",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_queries) } {
            return .{ .service_metadata = service_metadata, .action = describe_queries };
        }
    },
    Response: type = struct {
        queries: ?[]struct {
            query_id: ?[]const u8 = null,
            query_string: ?[]const u8 = null,
            status: ?[]const u8 = null,
            create_time: ?i64 = null,
            log_group_name: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .query_id = "queryId",
                    .query_string = "queryString",
                    .status = "status",
                    .create_time = "createTime",
                    .log_group_name = "logGroupName",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .queries = "queries",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const describe_query_definitions: struct {
    action_name: []const u8 = "DescribeQueryDefinitions",
    Request: type = struct {
        query_definition_name_prefix: ?[]const u8 = null,
        max_results: ?i64 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_definition_name_prefix = "queryDefinitionNamePrefix",
                .max_results = "maxResults",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_query_definitions) } {
            return .{ .service_metadata = service_metadata, .action = describe_query_definitions };
        }
    },
    Response: type = struct {
        query_definitions: ?[]struct {
            query_definition_id: ?[]const u8 = null,
            name: ?[]const u8 = null,
            query_string: ?[]const u8 = null,
            last_modified: ?i64 = null,
            log_group_names: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .query_definition_id = "queryDefinitionId",
                    .name = "name",
                    .query_string = "queryString",
                    .last_modified = "lastModified",
                    .log_group_names = "logGroupNames",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_definitions = "queryDefinitions",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const describe_resource_policies: struct {
    action_name: []const u8 = "DescribeResourcePolicies",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_resource_policies) } {
            return .{ .service_metadata = service_metadata, .action = describe_resource_policies };
        }
    },
    Response: type = struct {
        resource_policies: ?[]ResourcePolicy = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_policies = "resourcePolicies",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const describe_subscription_filters: struct {
    action_name: []const u8 = "DescribeSubscriptionFilters",
    Request: type = struct {
        log_group_name: []const u8,
        filter_name_prefix: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name_prefix = "filterNamePrefix",
                .next_token = "nextToken",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_subscription_filters) } {
            return .{ .service_metadata = service_metadata, .action = describe_subscription_filters };
        }
    },
    Response: type = struct {
        subscription_filters: ?[]struct {
            filter_name: ?[]const u8 = null,
            log_group_name: ?[]const u8 = null,
            filter_pattern: ?[]const u8 = null,
            destination_arn: ?[]const u8 = null,
            role_arn: ?[]const u8 = null,
            distribution: ?[]const u8 = null,
            creation_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .filter_name = "filterName",
                    .log_group_name = "logGroupName",
                    .filter_pattern = "filterPattern",
                    .destination_arn = "destinationArn",
                    .role_arn = "roleArn",
                    .distribution = "distribution",
                    .creation_time = "creationTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .subscription_filters = "subscriptionFilters",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const disassociate_kms_key: struct {
    action_name: []const u8 = "DisassociateKmsKey",
    Request: type = struct {
        log_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_kms_key) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_kms_key };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const filter_log_events: struct {
    action_name: []const u8 = "FilterLogEvents",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_names: ?[][]const u8 = null,
        log_stream_name_prefix: ?[]const u8 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        filter_pattern: ?[]const u8 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,
        interleaved: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_names = "logStreamNames",
                .log_stream_name_prefix = "logStreamNamePrefix",
                .start_time = "startTime",
                .end_time = "endTime",
                .filter_pattern = "filterPattern",
                .next_token = "nextToken",
                .limit = "limit",
                .interleaved = "interleaved",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(filter_log_events) } {
            return .{ .service_metadata = service_metadata, .action = filter_log_events };
        }
    },
    Response: type = struct {
        events: ?[]struct {
            log_stream_name: ?[]const u8 = null,
            timestamp: ?i64 = null,
            message: ?[]const u8 = null,
            ingestion_time: ?i64 = null,
            event_id: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .log_stream_name = "logStreamName",
                    .timestamp = "timestamp",
                    .message = "message",
                    .ingestion_time = "ingestionTime",
                    .event_id = "eventId",
                };
                return @field(mappings, field_name);
            }
        } = null,
        searched_log_streams: ?[]struct {
            log_stream_name: ?[]const u8 = null,
            searched_completely: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .log_stream_name = "logStreamName",
                    .searched_completely = "searchedCompletely",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events = "events",
                .searched_log_streams = "searchedLogStreams",
                .next_token = "nextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const get_log_events: struct {
    action_name: []const u8 = "GetLogEvents",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_name: []const u8,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        next_token: ?[]const u8 = null,
        limit: ?i64 = null,
        start_from_head: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_name = "logStreamName",
                .start_time = "startTime",
                .end_time = "endTime",
                .next_token = "nextToken",
                .limit = "limit",
                .start_from_head = "startFromHead",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_log_events) } {
            return .{ .service_metadata = service_metadata, .action = get_log_events };
        }
    },
    Response: type = struct {
        events: ?[]struct {
            timestamp: ?i64 = null,
            message: ?[]const u8 = null,
            ingestion_time: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamp = "timestamp",
                    .message = "message",
                    .ingestion_time = "ingestionTime",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_forward_token: ?[]const u8 = null,
        next_backward_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events = "events",
                .next_forward_token = "nextForwardToken",
                .next_backward_token = "nextBackwardToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const get_log_group_fields: struct {
    action_name: []const u8 = "GetLogGroupFields",
    Request: type = struct {
        log_group_name: []const u8,
        time: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .time = "time",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_log_group_fields) } {
            return .{ .service_metadata = service_metadata, .action = get_log_group_fields };
        }
    },
    Response: type = struct {
        log_group_fields: ?[]struct {
            name: ?[]const u8 = null,
            percent: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "name",
                    .percent = "percent",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_fields = "logGroupFields",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const get_log_record: struct {
    action_name: []const u8 = "GetLogRecord",
    Request: type = struct {
        log_record_pointer: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_record_pointer = "logRecordPointer",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_log_record) } {
            return .{ .service_metadata = service_metadata, .action = get_log_record };
        }
    },
    Response: type = struct {
        log_record: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_record = "logRecord",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "log_record", field_name))
                return try serializeMap(self.log_record, self.fieldNameFor("log_record"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const get_query_results: struct {
    action_name: []const u8 = "GetQueryResults",
    Request: type = struct {
        query_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_id = "queryId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_query_results) } {
            return .{ .service_metadata = service_metadata, .action = get_query_results };
        }
    },
    Response: type = struct {
        results: ?[][]struct {
            field: ?[]const u8 = null,
            value: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .field = "field",
                    .value = "value",
                };
                return @field(mappings, field_name);
            }
        } = null,
        statistics: ?struct {
            records_matched: ?f64 = null,
            records_scanned: ?f64 = null,
            bytes_scanned: ?f64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .records_matched = "recordsMatched",
                    .records_scanned = "recordsScanned",
                    .bytes_scanned = "bytesScanned",
                };
                return @field(mappings, field_name);
            }
        } = null,
        status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .results = "results",
                .statistics = "statistics",
                .status = "status",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const list_tags_log_group: struct {
    action_name: []const u8 = "ListTagsLogGroup",
    Request: type = struct {
        log_group_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_log_group) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_log_group };
        }
    },
    Response: type = struct {
        tags: ?[]struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }
    },
    ServiceError: type = error{
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const put_destination: struct {
    action_name: []const u8 = "PutDestination",
    Request: type = struct {
        destination_name: []const u8,
        target_arn: []const u8,
        role_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destination_name = "destinationName",
                .target_arn = "targetArn",
                .role_arn = "roleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_destination) } {
            return .{ .service_metadata = service_metadata, .action = put_destination };
        }
    },
    Response: type = struct {
        destination: ?Destination = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destination = "destination",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ServiceUnavailable,
    },
} = .{};
pub const put_destination_policy: struct {
    action_name: []const u8 = "PutDestinationPolicy",
    Request: type = struct {
        destination_name: []const u8,
        access_policy: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .destination_name = "destinationName",
                .access_policy = "accessPolicy",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_destination_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_destination_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ServiceUnavailable,
    },
} = .{};
pub const put_log_events: struct {
    action_name: []const u8 = "PutLogEvents",
    Request: type = struct {
        log_group_name: []const u8,
        log_stream_name: []const u8,
        log_events: []struct {
            timestamp: i64,
            message: []const u8,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .timestamp = "timestamp",
                    .message = "message",
                };
                return @field(mappings, field_name);
            }
        },
        sequence_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_stream_name = "logStreamName",
                .log_events = "logEvents",
                .sequence_token = "sequenceToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_log_events) } {
            return .{ .service_metadata = service_metadata, .action = put_log_events };
        }
    },
    Response: type = struct {
        next_sequence_token: ?[]const u8 = null,
        rejected_log_events_info: ?struct {
            too_new_log_event_start_index: ?i64 = null,
            too_old_log_event_end_index: ?i64 = null,
            expired_log_event_end_index: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .too_new_log_event_start_index = "tooNewLogEventStartIndex",
                    .too_old_log_event_end_index = "tooOldLogEventEndIndex",
                    .expired_log_event_end_index = "expiredLogEventEndIndex",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_sequence_token = "nextSequenceToken",
                .rejected_log_events_info = "rejectedLogEventsInfo",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        DataAlreadyAccepted,
        InvalidParameter,
        InvalidSequenceToken,
        ResourceNotFound,
        ServiceUnavailable,
        UnrecognizedClient,
    },
} = .{};
pub const put_metric_filter: struct {
    action_name: []const u8 = "PutMetricFilter",
    Request: type = struct {
        log_group_name: []const u8,
        filter_name: []const u8,
        filter_pattern: []const u8,
        metric_transformations: []MetricTransformation,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name = "filterName",
                .filter_pattern = "filterPattern",
                .metric_transformations = "metricTransformations",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_metric_filter) } {
            return .{ .service_metadata = service_metadata, .action = put_metric_filter };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const put_query_definition: struct {
    action_name: []const u8 = "PutQueryDefinition",
    Request: type = struct {
        name: []const u8,
        query_definition_id: ?[]const u8 = null,
        log_group_names: ?[][]const u8 = null,
        query_string: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .name = "name",
                .query_definition_id = "queryDefinitionId",
                .log_group_names = "logGroupNames",
                .query_string = "queryString",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_query_definition) } {
            return .{ .service_metadata = service_metadata, .action = put_query_definition };
        }
    },
    Response: type = struct {
        query_definition_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_definition_id = "queryDefinitionId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const put_resource_policy: struct {
    action_name: []const u8 = "PutResourcePolicy",
    Request: type = struct {
        policy_name: ?[]const u8 = null,
        policy_document: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_name = "policyName",
                .policy_document = "policyDocument",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_resource_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_resource_policy };
        }
    },
    Response: type = struct {
        resource_policy: ?ResourcePolicy = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_policy = "resourcePolicy",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        ServiceUnavailable,
    },
} = .{};
pub const put_retention_policy: struct {
    action_name: []const u8 = "PutRetentionPolicy",
    Request: type = struct {
        log_group_name: []const u8,
        retention_in_days: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .retention_in_days = "retentionInDays",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_retention_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_retention_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const put_subscription_filter: struct {
    action_name: []const u8 = "PutSubscriptionFilter",
    Request: type = struct {
        log_group_name: []const u8,
        filter_name: []const u8,
        filter_pattern: []const u8,
        destination_arn: []const u8,
        role_arn: ?[]const u8 = null,
        distribution: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .filter_name = "filterName",
                .filter_pattern = "filterPattern",
                .destination_arn = "destinationArn",
                .role_arn = "roleArn",
                .distribution = "distribution",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_subscription_filter) } {
            return .{ .service_metadata = service_metadata, .action = put_subscription_filter };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        OperationAborted,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const start_query: struct {
    action_name: []const u8 = "StartQuery",
    Request: type = struct {
        log_group_name: ?[]const u8 = null,
        log_group_names: ?[][]const u8 = null,
        start_time: i64,
        end_time: i64,
        query_string: []const u8,
        limit: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .log_group_names = "logGroupNames",
                .start_time = "startTime",
                .end_time = "endTime",
                .query_string = "queryString",
                .limit = "limit",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_query) } {
            return .{ .service_metadata = service_metadata, .action = start_query };
        }
    },
    Response: type = struct {
        query_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_id = "queryId",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        LimitExceeded,
        MalformedQuery,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const stop_query: struct {
    action_name: []const u8 = "StopQuery",
    Request: type = struct {
        query_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .query_id = "queryId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_query) } {
            return .{ .service_metadata = service_metadata, .action = stop_query };
        }
    },
    Response: type = struct {
        success: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .success = "success",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
        ServiceUnavailable,
    },
} = .{};
pub const tag_log_group: struct {
    action_name: []const u8 = "TagLogGroup",
    Request: type = struct {
        log_group_name: []const u8,
        tags: []struct {
            key: ?[]const u8 = null,
            value: ?[]const u8 = null,
        },

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
            if (std.mem.eql(u8, "tags", field_name))
                return try serializeMap(self.tags, self.fieldNameFor("tags"), options, out_stream);
            return false;
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_log_group) } {
            return .{ .service_metadata = service_metadata, .action = tag_log_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InvalidParameter,
        ResourceNotFound,
    },
} = .{};
pub const test_metric_filter: struct {
    action_name: []const u8 = "TestMetricFilter",
    Request: type = struct {
        filter_pattern: []const u8,
        log_event_messages: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter_pattern = "filterPattern",
                .log_event_messages = "logEventMessages",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(test_metric_filter) } {
            return .{ .service_metadata = service_metadata, .action = test_metric_filter };
        }
    },
    Response: type = struct {
        matches: ?[]struct {
            event_number: ?i64 = null,
            event_message: ?[]const u8 = null,
            extracted_values: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .event_number = "eventNumber",
                    .event_message = "eventMessage",
                    .extracted_values = "extractedValues",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "extracted_values", field_name))
                    return try serializeMap(self.extracted_values, self.fieldNameFor("extracted_values"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .matches = "matches",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InvalidParameter,
        ServiceUnavailable,
    },
} = .{};
pub const untag_log_group: struct {
    action_name: []const u8 = "UntagLogGroup",
    Request: type = struct {
        log_group_name: []const u8,
        tags: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .log_group_name = "logGroupName",
                .tags = "tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_log_group) } {
            return .{ .service_metadata = service_metadata, .action = untag_log_group };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        ResourceNotFound,
    },
} = .{};

pub const ResourcePolicy = struct {
    policy_name: ?[]const u8 = null,
    policy_document: ?[]const u8 = null,
    last_updated_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_name = "policyName",
            .policy_document = "policyDocument",
            .last_updated_time = "lastUpdatedTime",
        };
        return @field(mappings, field_name);
    }
};

pub const MetricTransformation = struct {
    metric_name: []const u8,
    metric_namespace: []const u8,
    metric_value: []const u8,
    default_value: ?f64 = null,
    dimensions: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]const u8 = null,
    } = null,
    unit: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .metric_name = "metricName",
            .metric_namespace = "metricNamespace",
            .metric_value = "metricValue",
            .default_value = "defaultValue",
            .dimensions = "dimensions",
            .unit = "unit",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "dimensions", field_name))
            return try serializeMap(self.dimensions, self.fieldNameFor("dimensions"), options, out_stream);
        return false;
    }
};

pub const Destination = struct {
    destination_name: ?[]const u8 = null,
    target_arn: ?[]const u8 = null,
    role_arn: ?[]const u8 = null,
    access_policy: ?[]const u8 = null,
    arn: ?[]const u8 = null,
    creation_time: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .destination_name = "destinationName",
            .target_arn = "targetArn",
            .role_arn = "roleArn",
            .access_policy = "accessPolicy",
            .arn = "arn",
            .creation_time = "creationTime",
        };
        return @field(mappings, field_name);
    }
};
